<script setup lang="ts">
import type { BlogPost } from '@/types/blog';

// Props
defineProps<BlogPost>();

// Methods
const handleLinkClick = (event: Event) => {
  let target = event.target;

  // I don't know why currentTarget is not working, so I wrote our own logic.
  // This is used when someone clicks the svg that's wrapped in an anchor tag.
  if (target?.tagName !== 'A' && event?.target?.closest('a')?.classList?.contains('header-anchor')) {
    target = event.target?.closest('a');
  }

  if (target?.tagName === 'A') {
    const href = target?.getAttribute('href');
    if (href && href.startsWith('#')) {
      // Internal anchor link, scroll to the target section
      event.preventDefault();
      const targetId = href.substring(1);
      const targetElement = document.getElementById(targetId);

      if (targetElement) {
        targetElement.scrollIntoView({ behavior: 'smooth' });
        const currentUrl = window.location.href;
        const updatedUrl = `${currentUrl.split('#')[0]}#${targetId}`;
        history.pushState(null, '', updatedUrl);
      }
    } else {
      // External link, follow the link (you can add additional logic if needed)
      window.location.href = href;
    }
  }
};
</script>

<template>
  <div v-if="body" class="body" @click="handleLinkClick" v-html="$md.render(body)" />
</template>

<style lang="scss" scoped>
.body {
  :deep(h1) {
    font-size: $text-heading-3;
    line-height: $line-height-heading-3;
    font-weight: $font-weight-bold;
    letter-spacing: $letter-spacing-heading-3-bold;
    margin-bottom: 24px;
    margin-top: 24px;
    @media (max-width: $breakpoint-sm) {
      font-size: $text-heading-3-mobile;
      line-height: $line-height-heading-3-mobile;
      letter-spacing: $letter-spacing-heading-3-bold-mobile;
    }
  }

  :deep(ol) {
    list-style: decimal;
    padding-left: $spacing-24;
  }

  :deep(ul) {
    list-style: disc;
    padding-left: $spacing-24;
  }

  :deep(table) {
    border-collapse: collapse;
    width: 100%;
  }

  :deep(td),
  :deep(th) {
    border: $border;
    padding: $spacing-8;
    text-align: left;
  }

  :deep(h2),
  :deep(h3),
  :deep(h4),
  :deep(h5) {
    margin-bottom: 24px;
    margin-top: 24px;
    font-weight: $font-weight-bold;
    letter-spacing: $letter-spacing-heading-2-bold-mobile;
    @media (max-width: $breakpoint-sm) {
      font-size: $text-heading-3-mobile;
      line-height: $line-height-heading-3-mobile;
      letter-spacing: $letter-spacing-heading-3-bold-mobile;
    }
  }

  :deep(p),
  :deep(li) {
    margin-bottom: 16px;
    font-size: $text-body-1;
    line-height: $line-height-body-1;
  }

  :deep(a) {
    color: $color-text-link-100;
  }

  :deep(li) {
    margin-bottom: 8px;

    p,
    a {
      margin-bottom: 0;
    }
  }

  :deep(ol),
  :deep(ul) {
    margin-bottom: 16px;
  }

  :deep(ol + ul) {
    padding-left: 40px;
  }

  :deep(hr) {
    margin-top: 8px;
    margin-bottom: 8px;
  }

  :deep(.video_container iframe) {
    width: 100%;
    height: 460px;
    margin-bottom: 24px;
    @media (max-width: $breakpoint-lg) {
      height: 240px;
    }
  }

  :deep(img) {
    max-width: 100%;
    object-fit: cover;
  }

  :deep(pre) {
    display: block;
    padding: 13px;
    margin: 0 0 13.5px;
    font-size: 16px;
    line-height: 1.5;
    word-break: break-all;
    background-color: #f5f5f5;
    border: 1px solid #ccc;
    white-space: pre-wrap;

    code,
    span {
      background-color: transparent;
      font-family: monospace;
      padding: 0;
    }
  }

  :deep(code) {
    font-family: monospace;
  }

  :deep(blockquote) {
    margin: 40px 0;
    display: flex;
    padding: 24px 40px;
    flex-direction: column;
    justify-content: center;
    align-items: flex-start;
    gap: 16px;
    border-radius: 4px;
    background: $color-surface-800;

    p {
      margin-bottom: 0;
    }
  }

  :deep(h1),
  :deep(h2),
  :deep(h3),
  :deep(h4),
  :deep(h5),
  :deep(h6) {
    position: relative;
  }

  :deep(.header-anchor) {
    position: absolute;
    left: -36px;
    top: 0;

    > * {
      visibility: hidden;
    }
  }

  :deep(*:hover) > .header-anchor,
  :deep(*:focus) > .header-anchor {
    > * {
      visibility: visible;
    }
  }
}
</style>
